# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/sun-javamail/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src
%define jar_name mail

%define jmailver  1.4
%define jmail_priority 14201

Name:           glassfish-javamail
Version:        1.4.2
Release:        0.4%{?dist}
Epoch:          0
Summary:        Glassfish - JavaMail API
Group:          Development/Java
License:        CDDL
URL:            http://glassfish.dev.java.net/
## cvs -Q -d :pserver:guest@cvs.dev.java.net:/cvs export -r JAVAMAIL-1_4_1 -d glassfish-javamail-1.4.1 glassfish/mail && tar cjf glassfish-javamail-1.4.1.tar.bz2 glassfish-javamail-1.4.1
# rm -rf glassfish-javamail-1.4.2 && hg -q clone -r JAVAMAIL-1_4_2 https://kenai.com/hg/javamail~mercurial glassfish-javamail-1.4.2 && tar cjf glassfish-javamail-1.4.2.tar.bz2 glassfish-javamail-1.4.2
### please add a svn rev # to the src tar ball when the tar ball is updated
### again for the same version or rpmdiff will complain that the src tar
### ball has changed but the version did not change.
Source0:        glassfish-javamail-1.4.2.tar.bz2
# this tar is a tar of the legal folder under glassfish/bootstrap
## rm -rf legal && mkdir -p legal/src/main/resources && cvs -Q -d :pserver:guest@cvs.dev.java.net:/cvs export -r HEAD -d legal/src/main/resources glassfish/bootstrap/legal/LICENSE.txt && tar cjf glassfish-javamail-1.4.1-license.tar.bz2 legal
# rm -rf legal && wget -q http://download.java.net/maven/2/javax/mail/mail/1.4.2/mail-1.4.2-sources.jar && mkdir -p legal/src/main/resources && unzip -qq -d legal/src/main/resources mail-1.4.2-sources.jar META-INF/LICENSE.txt && tar cjf glassfish-javamail-license-1.4.2.tar.bz2 legal
Source1:        glassfish-javamail-license-1.4.2.tar.bz2
Source2:        http://download.java.net/maven/2/javax/mail/mail/1.4.2/mail-1.4.2.pom
Source3:        %{name}-component-info.xml
Provides:       javamail = 0:%{jmailver}
Provides:       javamail-monolithic = 0:%{jmailver}
Provides:       javamail_1_4_api = %{epoch}:%{version}-%{release}
Provides:       javamail_api = 0:1.4
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires(post): %{_sbindir}/update-alternatives
Requires(preun): %{_sbindir}/update-alternatives
Requires:       jaf_1_1_api
Requires:       jpackage-utils
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  jaf_1_1_api
BuildRequires:  servlet_2_5_api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JavaMail API from GlassFish.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:       javamail-javadoc = 0:%{jmailver}
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%setup -q -T -D -a 1
mv legal/src/main/resources/META-INF/LICENSE.txt legal/src/main/resources/META-INF/LICENSE.txt.orig
%{_bindir}/iconv -f iso88591 -t utf8 -o legal/src/main/resources/META-INF/LICENSE.txt legal/src/main/resources/META-INF/LICENSE.txt.orig

%build
export CLASSPATH=$(build-classpath jaf_1_1_api servlet_2_5_api)
export OPT_JAR_LIST=:
%{ant} -Dspec.dir=$(pwd)/doc/spec release

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 0644 target/release/%{jar_name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-monolithic-%{version}.jar
install -p -m 0644 target/release/lib/dsn.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/dsn-%{version}.jar
install -p -m 0644 target/release/lib/imap.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/imap-%{version}.jar
install -p -m 0644 target/release/lib/mailapi.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/mailapi-%{version}.jar
install -p -m 0644 target/release/lib/pop3.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/pop3-%{version}.jar
install -p -m 0644 target/release/lib/smtp.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/smtp-%{version}.jar

%add_to_maven_depmap javax.mail mail %{version} JPP %{name}-monolithic
%add_to_maven_depmap javax.mail dsn %{version} JPP/%{name} dsn
%add_to_maven_depmap javax.mail imap %{version} JPP/%{name} imap
%add_to_maven_depmap javax.mail mailapi %{version} JPP/%{name} mailapi
%add_to_maven_depmap javax.mail pop3 %{version} JPP/%{name} pop3
%add_to_maven_depmap javax.mail smtp %{version} JPP/%{name} smtp

pushd $RPM_BUILD_ROOT%{_javadir}
ln -s %{name}-monolithic-%{version}.jar %{name}.jar
ln -s %{name}-monolithic-%{version}.jar %{name}-monolithic.jar
popd

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)

/bin/touch $RPM_BUILD_ROOT%{_javadir}/javamail.jar
/bin/touch $RPM_BUILD_ROOT%{_javadir}/javamail_api.jar
/bin/touch $RPM_BUILD_ROOT%{_javadir}/javamail_1_4_api.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/release/docs/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}.jar $RPM_BUILD_ROOT%{repodirlib}/mail.jar
install -pm 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirlib}/mail.pom
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{_sbindir}/update-alternatives --install %{_javadir}/javamail.jar javamail %{_javadir}/%{name}-monolithic.jar %{jmail_priority}
%{_sbindir}/update-alternatives --install %{_javadir}/javamail_api.jar javamail_api %{_javadir}/%{name}-monolithic.jar %{jmail_priority}
%{_sbindir}/update-alternatives --install %{_javadir}/javamail_1_4_api.jar javamail_1_4_api %{_javadir}/%{name}-monolithic.jar %{jmail_priority}
%update_maven_depmap

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove javamail %{_javadir}/%{name}-monolithic.jar
    %{_sbindir}/update-alternatives --remove javamail_api %{_javadir}/%{name}-monolithic.jar
    %{_sbindir}/update-alternatives --remove javamail_1_4_api %{_javadir}/%{name}-monolithic.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc legal/src/main/resources/META-INF/LICENSE.txt
%{_javadir}/%{name}-monolithic-%{version}.jar
%{_javadir}/%{name}-monolithic.jar
%{_javadir}/%{name}.jar
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/dsn-%{version}.jar
%{_javadir}/%{name}/dsn.jar
%{_javadir}/%{name}/imap-%{version}.jar
%{_javadir}/%{name}/imap.jar
%{_javadir}/%{name}/mailapi-%{version}.jar
%{_javadir}/%{name}/mailapi.jar
%{_javadir}/%{name}/pop3-%{version}.jar
%{_javadir}/%{name}/pop3.jar
%{_javadir}/%{name}/smtp-%{version}.jar
%{_javadir}/%{name}/smtp.jar
%{_datadir}/maven2/poms/JPP.%{name}.pom
%{_mavendepmapfragdir}/%{name}
%ghost %{_javadir}/javamail.jar
%ghost %{_javadir}/javamail_api.jar
%ghost %{_javadir}/javamail_1_4_api.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Nov 01 2010 David Walluck <dwalluck@redhat.com> 0:1.4.2-0.4
- add javamail alternatives and Provides

* Tue Aug 31 2010 Fernando Nasser <fnasser@redhat.com> 0:1.4.2-0.3.2
- Fix alternatives priority
- Install pom in repolib

* Wed May 05 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.4.2-0.3.1
- rebuilt

* Fri Apr 02 2010 Yong Yang <yyang@redhat.com> 0:1.4.2-0.3
- Rebuild

* Wed Aug 12 2009 David Walluck <dwalluck@redhat.com> 0:1.4.2-0.2
- use simplified pom

* Tue Aug 11 2009 David Walluck <dwalluck@redhat.com> 0:1.4.2-0.1
- 1.4.2
- fix Requires

* Mon Apr 13 2009 David Walluck <dwalluck@redhat.com> 0:1.4.0-4
- fix repolib
- rename repolib location to sun-javamail to match upstream

* Fri Jul 18 2008 David Walluck <dwalluck@redhat.com> 0:1.4.0-3
- remove javadoc Requires(post)
- fix repolib location

* Fri Jul 18 2008 David Walluck <dwalluck@redhat.com> 0:1.4.0-2
- quiet setup
- use macros
- fix %%doc
- change repolib component id
- peroperly unpack sources
- update BuildRoot
- fix repolib permissions
- fix maven directory ownership

* Mon Jun 02 2008 Permaine Cheung <pcheung@redhat.com> 0:1.4.0-1
- First JPP 5 build

* Mon Mar 31 2008 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.9
- Removed the post/postun javadoc sections (Taken care of by install and files javadoc sections)

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-0jpp.ep1.8
- Revert to sun-javamail name due to buildmagic

* Fri Nov 23 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.7
- Build with debug info

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.4.0-0jpp.ep1.6
- Parametrize component-info contents

* Thu Nov 22 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.5
- Adding component-info.xml
- Change the repodir to glassfish/javamail

* Tue Nov 20 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.4
- Adding in pom stuff

* Fri Nov 16 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.3
- Adding glassfish-jaf to the classpath

* Fri Nov 16 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.2
- Rebuild

* Thu Nov 15 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.4.0-0jpp.ep1.1
- First release.
